<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_PERSONAL_MATERIAL_RETURN';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/inventory/includes/ui/personal_material_returns_ui.inc");
include_once($path_to_root . "/inventory/includes/db/job_material_issues_db.inc");
include_once($path_to_root . "/inventory/includes/db/personal_material_issues_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/personal_material_transfers_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/db/inventory_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/lot_allocations_db.inc");  
include_once($path_to_root . "/inventory/includes/ui/lot_ui.inc");  
include_once($path_to_root . "/inventory/includes/db/lots_db.inc");   
include_once($path_to_root . "/includes/approval_functions.inc");   
include_once($path_to_root . "/payroll/includes/db/employees_db.inc");   

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if (isset($_GET['ProcessedID'])) {
    page(_($help_context = $systypes_array[ST_PERSONAL_MATERIAL_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['ProcessedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmrt_messages');
    clear_session_variable('pmrt_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    page(_($help_context = $systypes_array[ST_PERSONAL_MATERIAL_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmrt_bo_messages');
    clear_session_variable('pmrt_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    page(_($help_context = $systypes_array[ST_PERSONAL_MATERIAL_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('pmrt_rj_messages');
    clear_session_variable('pmrt_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if ((isset($_GET['pmi_no']) && is_numeric($_GET['pmi_no'])) || (isset($_POST['pmi_no']) && is_numeric($_POST['pmi_no']))) {
    $_POST['pmi_no'] = isset($_GET['pmi_no']) ? $_GET['pmi_no'] : $_POST['pmi_no'];
    
    $header = get_job_material_issue_header_record($_POST['pmi_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_PERSONAL_MATERIAL_ISSUE) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_PERSONAL_MATERIAL_ISSUE]." record #".$_POST['pmi_no']));
            display_footer_exit();
        }
    
    $page_title = _('New '.$systypes_array[ST_PERSONAL_MATERIAL_RETURN]);
    
} elseif ((isset($_GET['pmrt_no']) && is_numeric($_GET['pmrt_no'])) || (isset($_POST['pmrt_no']) && is_numeric($_POST['pmrt_no']))) {
    $_POST['pmrt_no'] = isset($_GET['pmrt_no']) ? $_GET['pmrt_no'] : $_POST['pmrt_no'];
    
    $header = get_job_material_issue_header_record($_POST['pmrt_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_PERSONAL_MATERIAL_RETURN) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_PERSONAL_MATERIAL_RETURN]." record #".$_POST['pmrt_no']));
            display_footer_exit();
        }
        
    $_POST['pmi_no'] = $header['jmr_no'];
    $page_title = _('Modify '.$systypes_array[ST_PERSONAL_MATERIAL_RETURN]." #".$header['trans_no'] );
    
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Could not find ".$systypes_array[ST_PERSONAL_MATERIAL_RETURN]));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_POST['Process_PMTRRT'])) {
    $msg = save_personal_material_returns($_POST['pmi_no'], $_POST['pmrt_no'], true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_PMTRRT'])) {
    $msg = back_to_originator_personal_material_return($_POST['pmrt_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_PMTRRT'])) {
    $msg = reject_personal_material_return($_POST['pmi_no'], $_POST['pmrt_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Create_PMTRRT'])) {        
    $msg = save_personal_material_returns($_POST['pmi_no'], $_POST['pmrt_no']);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            $transfer_hd_row = get_job_material_issue_header_record($_POST['pmrt_no']);
                if (! is_array($transfer_hd_row)) {
                    $pmrt_no = $_POST['pmrt_no'] = 0; 
                }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
        }
}

global $Ajax;

start_form();

    if (isset($_POST['pmi_no']) && $_POST['pmi_no'] > 0) {
        hidden('pmi_no', $_POST['pmi_no']);
    } else {
        $_POST['pmi_no'] = 0;
    }   
        
    if (isset($_POST['pmrt_no']) && $_POST['pmrt_no'] > 0) {
        hidden('pmrt_no', $_POST['pmrt_no']);
        $button_name = 'Save';
    } else {
        $_POST['pmrt_no'] = 0;
        $button_name = 'Create';
    }

    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        $trn_hd_row = display_personal_material_issue_header_details($_POST['pmi_no'], $_POST['pmrt_no']);
        
        display_personal_material_return_header($_POST['pmrt_no'], $trn_hd_row);

        display_personal_material_return_details($_POST['pmi_no'], $_POST['pmrt_no']);

            submit_center_first('Create_PMTRRT', _("$button_name ".$systypes_array[ST_PERSONAL_MATERIAL_RETURN]), '', 'default');    
            
            $header = get_job_material_issue_header($_POST['pmrt_no']);
            if (is_array($header)) {
                submit('Process_PMTRRT', _("Process ".$systypes_array[ST_PERSONAL_MATERIAL_RETURN]), true, _("Process"), false, ICON_SUBMIT);
            } 
                
            submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT); 
            
            start_table();
                if (is_array($header)) {
                    br(2);
                    submit_center_first('REJECT_PMTRRT', _("Reject ".$systypes_array[ST_PERSONAL_MATERIAL_RETURN]), '', true, ICON_DELETE);   
                    
                    submit('BACK_TO_ORIGINATOR_PMTRRT', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                }
            end_table();

    div_end();
    
end_form(2);
end_page(@$_GET['popup'], false, false);        

?>